var outputFile = 'news', RssBraider = require('rss-braider'), fs = require('fs'), ejs = require(
  'ejs'), read = require('fs').readFileSync, join = require('path').join, str = read(
  join(__dirname, '/templates/rss.ejs'),
  'utf8'), feeds = {};

var argv = require('yargs').argv;

var log4js = require('log4js');
var logger = log4js.getLogger();

// Pull feeds from config files: ,
//      feeds.simple_test_feed = require("./config/feed").feed;
// Or define in-line

feeds.simple_test_feed = {
  "feed_name": "feed",
  "default_count": 1,
  "no_cdata_fields": ['description'], // Don't wrap these fields in CDATA tags
  "meta": {
    "title": "News",
    "description": "Combined News Feed",
    'site_url': 'http://pipes.silvrtree.co.uk/news.xml'
  },
  "plugins": [
    'filter_3_days', 'fix_images', 'fix_scripts'
  ],
  'custom_namespaces'   : {
            "content"   : "http://purl.org/rss/1.0/modules/content/",
            "slash"     : "http://purl.org/rss/1.0/modules/slash/",
            "media"     : "http://search.yahoo.com/mrss/",
            "ev"        : "http://purl.org/rss/2.0/modules/event/",
            "sy"        : "http://purl.org/rss/1.0/modules/syndication/",
            "wfw"       : "http://wellformedweb.org/CommentAPI/",
            "dc"        : "http://purl.org/dc/elements/1.1/",
            "atom"      : "http://www.w3.org/2005/Atom"
        },
  "sources": [
    {
      "count": 100,
      "feed_url": "http://qz.com/feed/"
    },
    {
      "count": 100,
      "feed_url": "http://feeds2.feedburner.com/businessinsider"
    },
    {
      "count": 100,
      "feed_url": "http://feeds.reuters.com/reuters/UKTopNews"
    },
    {
      "count": 100,
      "feed_url": "http://feeds.reuters.com/reuters/UKdomesticNews"
    },
    {
      "count": 100,
      "feed_url": "http://feeds.reuters.com/reuters/UKWorldNews"
    },
    {
      "count": 100,
      "feed_url": "http://feeds.reuters.com/reuters/topNews"
    },
    {
      "count": 100,
      "feed_url": "http://feeds.reuters.com/Reuters/worldNews"
    }

    ,
    /*{
      "count": 100,
      "feed_url": "http://feeds.reuters.com/reuters/globalmarketsNews"
    },*/
    {
      "count": 100,
      "feed_url": "http://hosted2.ap.org/atom/APDEFAULT/cae69a7523db45408eeb2b3a98c0c9c5"
    },
    {
      "count": 100,
      "feed_url": "http://www.cityam.com/feeds/main.xml"
    },
    {
      "count": 100,
      "feed_url": "http://www.londonlovesbusiness.com/navrss?navsectioncode=121"
    },
    {
      "count": 100,
      "feed_url": "http://www.ibtimes.co.uk/rss/uk"
    },
    {
      "count": 100,
      "feed_url": "http://feeds.bbci.co.uk/news/rss.xml?edition=uk"
    },
    {
      "count": 100,
      "feed_url": "http://feeds.bbci.co.uk/news/scotland/rss.xml?edition=uk"
    },
    {
      "count": 100,
      "feed_url": "http://news.google.com/?output=rss"
    },
    {
      "count": 100,
      "feed_url": "http://feeds.feedburner.com/TheAtlantic"
    },
    {
      "count": 100,
      "feed_url": "http://www.telegraph.co.uk/news/rss.xml"
    },
    {
      "count": 100,
      "feed_url": "http://www.guardian.co.uk/rssfeed/0,,1,00.xml"
    },
    {
      "count": 100,
      "feed_url": "http://www.marketwatch.com/rss/topstories"
    },
    {
      "count": 100,
      "feed_url": "http://feeds.feedburner.com/wingsoverscotland/FgKv"
    },
    {
      "count": 100,
      "feed_url": "http://bellacaledonia.org.uk/feed/"
    }
    ,
        {
          "count": 100,
          "feed_url": "http://www.theweek.co.uk/feeds/all"
        }
    ,
            {
              "count": 100,
              "feed_url": "http://fivethirtyeight.com/all/feed"
            }
  ]
}

;
var braider_options = {
  feeds: feeds,
  indent: "    ",
  date_sort_order: "desc", // Newest first
  log_level: "warn",
  dedupe_fields: ['link', 'guid'],
  plugins_directories: [__dirname + "/plugins/"]
};
var rss_braider = RssBraider.createClient(braider_options);

// Override logging level (debug, info, warn, err, off)
//rss_braider.logger.level('off');

rss_braider.processFeed('simple_test_feed', 'json', function(err, data) {
  console.log('A');
  if (err) {
    logger.error(err);
    return err;
  }

  console.log('B');

  var j = JSON.parse(data);

  console.log('C');
  var ejsOutput = ejs.compile(str)(j);

  console.log('D');
  fs.writeFile(__dirname + "/dist/" + outputFile + ".html",
    ejsOutput,
    function(err) {

      if (err) {
        logger.error(err);
        return console.error(err);
      }

      console.log("The file was saved!");
    });

  fs.writeFile(__dirname + "/dist/" + outputFile + ".json",
    data,
    function(err) {
      if (err) {
        logger.error(err);
        return console.error(err);
      }

      console.log("The file was saved!");
    });
});
